/**********
**          TestApp.cpp
*/

#include <stdio.h>
#include <windows.h>
#include <winioctl.h>

#include "..\Common\IoCtl.h"


/****
***     main
*/
int __cdecl main(int argc, CHAR* argv[])
{
    HANDLE                  hDevice;
    DWORD                   dwError = ERROR_SUCCESS,
                            dwBytes;
    KERNEL_MATH_REQUEST     Request;
    KERNEL_MATH_RESPONSE    Response;

    printf("Opening \\\\.\\KernelSum device...\n");

    hDevice = CreateFile("\\\\.\\KernelSum",
                         GENERIC_ALL,
                         0,
                         NULL,
                         OPEN_EXISTING,
                         0,
                         NULL);

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf("Error #%d opening device...\n",
               (dwError = GetLastError()));
        return dwError;
    }

    Request.x = 3;
    Request.y = 2;

    printf("Calling DeviceIoControl...\n");

    if (!DeviceIoControl(hDevice,
                         IOCTL_ADD_THESE_TWO_NUMBERS,
                         &Request,
                         sizeof(KERNEL_MATH_REQUEST),
                         &Response,
                         sizeof(KERNEL_MATH_RESPONSE),
                         &dwBytes,
                         NULL))
    {
        printf("Error #%d calling DeviceIoControl...\n",
               (dwError = GetLastError()));

        CloseHandle(hDevice);
        return dwError;
    }

    printf("%d + %d = %d\n",
           Request.x,
           Request.y,
           Response.r);

    printf("Closing device...\n");

    CloseHandle(hDevice);
    return 0;
}

