#include <stdio.h>
#include <windows.h>
#include <winioctl.h>

#include "..\Common\IoCtl.h"

int main(){
	HANDLE                  hDevice;
    DWORD                   dwError = ERROR_SUCCESS,
                            dwBytes;
    KERNEL_MATH_REQUEST     Request;
    KERNEL_MATH_RESPONSE    Response;

    printf("Opening \\\\.\\SymbolicKernel device...\n");

	hDevice = CreateFile(L"\\\\.\\SymbolicKernel",
                         GENERIC_ALL,
                         0,
                         NULL,
                         OPEN_EXISTING,
                         0,
                         NULL);

	printf("%p\n", hDevice);

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf("Error #%d opening device...\n",
               (dwError = GetLastError()));
        return dwError;
    }

    Request.x = 7;
    Request.y = 5;

    printf("Calling DeviceIoControl...\n");

    if (!DeviceIoControl(hDevice,
                         IOCTL_ADD_THESE_TWO_NUMBERS,
                         &Request,
                         sizeof(KERNEL_MATH_REQUEST),
                         &Response,
                         sizeof(KERNEL_MATH_RESPONSE),
                         &dwBytes,
                         NULL))
    {
        printf("Error #%d calling DeviceIoControl...\n",
               (dwError = GetLastError()));

        CloseHandle(hDevice);
        return dwError;
    }

    printf("%d + %d = %d\n",
           Request.x,
           Request.y,
           Response.r);

    printf("Closing device...\n");

    CloseHandle(hDevice);
	getchar();

	return 0;
}